import java.util.ArrayList;

//Wir implementieren eine Turingmaschine mit den folgenden vereinfachenden Annahmen:
//Q={0,1,2,3,4}   N={}   T={0,1}   s=1   q+:=5 ,q-:=6   Delta wird bergeben

public class machine{

public static boolean debug=false;

//Zhlt die Einser auf dem Band
public static int countOnes(ArrayList BandIn){
  int result=0;
  Object[] Band=BandIn.toArray();
  for(int i=0;i<Band.length;i++)
    if(((Boolean) Band[i]).booleanValue())
      result++;
  return result;
}

public static int bool2int(Boolean in){
if(in.booleanValue()) return 1;
                 else return 0;                 
}

public static Boolean int2bool(int in){
if(in==1) return new Boolean(true);
    else return new Boolean(false);
}

//Gib Bandinhalt auf Schirm aus
public static void print(ArrayList BandIn){
System.out.println("Beginne Bandausgabe:");
  Object[] Band=BandIn.toArray();
  for(int i=0;i<Band.length;i++)
    System.out.print(bool2int((Boolean) Band[i]));
System.out.println();
System.out.println("Ende der Bandausgabe, "+Band.length+" bit geschrieben.");
}

//bersetze die Moveanweisung in Buchstaben
public static String trans(int in){
if(in==0) return "L";
if(in==1) return "R";
return "S";
}

//drucke Delta Funktion
public static void printMachine(QxTxLRS[][] Delta){
System.out.println("Printing Delta Function:");
for(int q=0;q<5;q++){
  for(int t=0;t<2;t++){
    System.out.print("("+q+","+t+")->("+Delta[q][t].Q+","+Delta[q][t].T+","+trans(Delta[q][t].LRS)+") | ");
    }
  System.out.println();
  }
}

private QxTxLRS[][] Delta=new QxTxLRS[5][2];
private ArrayList Band=new ArrayList();
private int Position=0;
private int state;

public machine(QxTxLRS[][] Delta){
Band.add(new Boolean(false));  //init Band
state=0;                       //set Startstate
for(int q=0;q<5;q++)
  for(int t=0;t<2;t++){
    if(q<Delta.length && t<Delta[q].length)
      this.Delta[q][t]=Delta[q][t];         //gegebene Zustnde kopieren
    else
      this.Delta[q][t]=new QxTxLRS();       //...Rest mit dummys auffllen
  }
}

public int run(long StepLimit,long BandLimit ,boolean show){//run machine; needs to be inited first with contructor
int count=0;
while(state<5 && count<StepLimit && Band.size()<BandLimit){
  if(Position<0){                       //Band ins Negative ausbauen falls ntig
    Band.add(0,new Boolean(false));
    Position=0;
    }
  else if(Position>=Band.size()){        //Band ins Positive ausbauen falls ntig
    Band.add(new Boolean(false));
    }
  if(debug) System.out.print("Pos: "+Position+" state: "+state);
  if(debug) print(Band);
  QxTxLRS next=Delta[state][bool2int((Boolean) Band.get(Position))];
  state=next.Q;
  Band.set(Position,int2bool(next.T));
  if(next.LRS==0) Position--;
  if(next.LRS==1) Position++;
                //else LRS==2  also stehenbleiben
  count++;
  }
//state ist groesser 4, Endzustand erreicht oder Schrittlimit berschritten
if(show){              //show result if wanted
  print(Band);
  if(count<StepLimit && Band.size()<BandLimit)
    System.out.println("Halt nach "+count+" Schritten durch erreichen von "+state+".");
  else
    if(Band.size()<BandLimit)
      System.out.println("Kein Anhalten in Sicht, gestoppt nach ueberschreiten des Schrittlimits.");
    else
      System.out.println("Kein Anhalten in Sicht, gestoppt nach ueberschreiten des Bandlimits.");
  printMachine(Delta);
  }
if(count<StepLimit && Band.size()<BandLimit) return countOnes(Band);//im Limit angehalten
return -1;                             //nicht beizeiten angehalten
}

public static QxTxLRS[][] emptyMachine(){
QxTxLRS[][] result=new QxTxLRS[5][2];
for(int q=0;q<5;q++)
  for(int t=0;t<2;t++)
    result[q][t]=new QxTxLRS();       //mit dummys fllen
return result;
}

public static QxTxLRS[][] zeroMachine(){
QxTxLRS[][] result=new QxTxLRS[5][2];
for(int q=0;q<5;q++)
  for(int t=0;t<2;t++)
    result[q][t]=new QxTxLRS(0,0,0);  //mit dummys fllen
return result;
}


//main Methode nur fr Testzwecke

public static void main(String[] argv){
//Test 1  : do nothing
//QxTxLRS[][] test=emptyMachine();

//Test 2  : 1111
//QxTxLRS[][] test=new QxTxLRS[2][2];
//test[0][0]=new QxTxLRS(1,1,"R");
//test[0][1]=new QxTxLRS(1,1,"L");
//test[1][0]=new QxTxLRS(0,1,"L");
//test[1][1]=new QxTxLRS(5,1,"S");

//Test 3  : 15 Einser
QxTxLRS[][] test=new QxTxLRS[5][2];
test[0][0]=new QxTxLRS(3,1,"R");
test[0][1]=new QxTxLRS(4,1,"R");
test[1][0]=new QxTxLRS(0,1,"R");
test[1][1]=new QxTxLRS(2,1,"L");
test[2][0]=new QxTxLRS(1,1,"L");
test[2][1]=new QxTxLRS(3,1,"L");
test[3][0]=new QxTxLRS(2,1,"L");
test[3][1]=new QxTxLRS(1,0,"L");
test[4][0]=new QxTxLRS(5,1,"R");
test[4][1]=new QxTxLRS(1,1,"R");

/*
//Test 4  : 4098 Einser, ~ 12 Mio. steps
QxTxLRS[][] test=new QxTxLRS[5][2];
test[0][0]=new QxTxLRS(1,1,"L");
test[0][1]=new QxTxLRS(0,1,"L");
test[1][0]=new QxTxLRS(2,1,"R");
test[1][1]=new QxTxLRS(1,1,"R");
test[2][0]=new QxTxLRS(0,1,"L");
test[2][1]=new QxTxLRS(3,1,"R");
test[3][0]=new QxTxLRS(0,1,"L");
test[3][1]=new QxTxLRS(4,1,"R");
test[4][0]=new QxTxLRS(5,1,"S");
test[4][1]=new QxTxLRS(2,0,"R");
*/

machine x=new machine(test);
System.out.println(x.run(100000000,10000,true)+" Einser");
}


}
